; *******************************************************************
; *** This software is copyright 2004 by Michael H Riley          ***
; *** You have permission to use, modify, copy, and distribute    ***
; *** this software so long as this copyright notice is retained. ***
; *** This software may not be used in commercial applications    ***
; *** without express written permission from the author.         ***
; *******************************************************************

include    bios.inc
include    kernel.inc

           org     8000h
           db      'DIR',0
           dw      9000h
           dw      endrom+7000h
           dw      2000h
           dw      endrom-2000h
           dw      2000h
           db      0

           org     2000h
           br      start

include    date.inc

start:     ldi     high crlf           ; display a cr/lf
           phi     rf
           ldi     low crlf
           plo     rf
           sep     scall
           dw      f_msg
           ghi     ra
           phi     rf
           glo     ra
           plo     rf
           sep     scall               ; open the directory
           dw      o_opendir
dirloop:   ldi     0                   ; need to read 32 bytes
           phi     rc
           ldi     32
           plo     rc
           ldi     high buffer         ; setup transfer buffer
           phi     rf
           ldi     low buffer
           plo     rf
           sep     scall               ; read files from dir
           dw      o_read
           glo     rc                  ; see if eof was hit
           smi     32
           bnz     dirdone             ; jump if done
           ldi     high buffer         ; setup transfer buffer
           phi     rf
           ldi     low buffer
           plo     rf
           lda     rf                  ; check for good entry
           bnz     dirgood
           lda     rf                  ; check for good entry
           bnz     dirgood
           lda     rf                  ; check for good entry
           bnz     dirgood
           lda     rf                  ; check for good entry
           bnz     dirgood
           br      dirloop             ; not a valid entry, loop back
dirgood:   ldi     low buffer          ; point to filename
           adi     12
           plo     rf
           ldi     high buffer
           adci    0
           phi     rf
           sep     scall               ; display the name
           dw      f_msg
           ldi     low buffer          ; point to flags
           adi     6
           plo     rf
           ldi     high buffer
           adci    0
           phi     rf
           ldn     rf                  ; get flags
           ani     1                   ; see if entry is a directory
           bz      notdir              ; jump if not
           ldi     '/'                 ; indicate a dir
           sep     scall
           dw      f_type
notdir:    ldi     high crlf           ; display a cr/lf
           phi     rf
           ldi     low crlf
           plo     rf
           sep     scall
           dw      f_msg
           br      dirloop             ; loop for next entry
dirdone:   sep     scall               ; close the directory
           dw      o_close
           sep     sret                ; return to os
crlf:      db      10,13,0

endrom:    equ     $

buffer:    ds      32
